
module fifo2mig_axi
#(
  parameter WR_DDR_BYTE_ADDR_BEGIN = 0      ,   //дʼַ
  parameter WR_DDR_BYTE_ADDR_END   = 200    ,   //дݽַ   
  parameter RD_DDR_BYTE_ADDR_BEGIN = 0      ,   //ʼַ
  parameter RD_DDR_BYTE_ADDR_END   = 200    ,   //ݵĽַ
  parameter AXI_LEN                = 8'd31,     //burst length = 32Ҫдݵĳ
  parameter AXI_ID                 = 4'b0000    //ӦID
)
(
  //FIFO Interface portsFIFOӦ˿źţ
  input               wr_addr_clr         ,     //дFIFOտźţִղʱҪ֤3ʱڵĸߵƽ
  output              wr_fifo_rdreq       ,     //FIFOд
  input     [127:0]   wr_fifo_rddata      ,     //FIFOҪд
  input               wr_fifo_empty       ,     //FIFOΪձ־ź
  input     [5:0]     wr_fifo_rd_cnt      ,     //дFIF0ݼ
  input               wr_fifo_rst_busy    ,     //дʱӸλæźţΪ1ʾλУΪ0ʾλɣ

  input               rd_addr_clr         ,     //FIFOտźţִղʱҪ֤3ʱڵĸߵƽ          
  output              rd_fifo_wrreq       ,     //FIFOĶ                                        
  output    [127:0]   rd_fifo_wrdata      ,     //FIFOȡ                                      
  input               rd_fifo_alfull      ,     //FIFOΪձ־ź                                      
  input     [5:0]     rd_fifo_wr_cnt      ,     //FIF0Ķ                                       
  input               rd_fifo_rst_busy    ,     //ʱӸλæźţΪ1ʾλУΪ0ʾλɣ                      
  // Application interface portsDDR3ûӿڣ
  input               ui_clk              ,     //ûʱź
  input               ui_clk_sync_rst     ,     //ûิλź
  input               mmcm_locked         ,     //PLLźţΪ1ʾ
  input               init_calib_complete ,     // DDR ⲿ DDR3 洢ʼУ׼źţΪ1ʾɣԶDDR3жд
  // Slave Interface Write Address Portsӽӿдַӿڣ
  output    [3:0]     m_axi_awid          ,     //дַID
  output reg[27:0]    m_axi_awaddr        ,     //һͻдַ
  output    [7:0]     m_axi_awlen         ,     //ͻдݳ
  output    [2:0]     m_axi_awsize        ,     //ͻдݵĴС
  output    [1:0]     m_axi_awburst       ,     //ͻд;
  output    [0:0]     m_axi_awlock        ,     //
  output    [3:0]     m_axi_awcache       ,     //cache
  output    [2:0]     m_axi_awprot        ,     //
  output    [3:0]     m_axi_awqos         ,     //
  output reg          m_axi_awvalid       ,     //дַЧź
  input               m_axi_awready       ,     //дַ׼ź
  // Slave Interface Write Data Portsдͨźţ
  output    [127:0]   m_axi_wdata         ,     //д
  output    [15:0]    m_axi_wstrb         ,     //дЧֽڷ
  output reg          m_axi_wlast         ,     //һݴ
  output reg          m_axi_wvalid        ,     //дЧ
  input               m_axi_wready        ,     //д
  // Slave Interface Write Response PortsдӦͨźţ
  input     [3:0]     m_axi_bid           ,     //дӦID
  input     [1:0]     m_axi_bresp         ,     //дӦ2'b00 OKAY 2'b01 EXOKAY 2'b10 SLVERR 2'b11DECERR
  input               m_axi_bvalid        ,     //дӦЧ
  output              m_axi_bready        ,     //Ӧ
  // Slave Interface Read Address Portsַӿڣ
  output    [3:0]     m_axi_arid          ,      //ַID                      
  output reg[27:0]    m_axi_araddr        ,      //һͻĶַ          
  output    [7:0]     m_axi_arlen         ,      //ͻݳ                    
  output    [2:0]     m_axi_arsize        ,      //ͻݵĴС                   
  output    [1:0]     m_axi_arburst       ,      //ͻ                      
  output    [0:0]     m_axi_arlock        ,      //                        
  output    [3:0]     m_axi_arcache       ,      //cache                    
  output    [2:0]     m_axi_arprot        ,      //                       
  output    [3:0]     m_axi_arqos         ,      //                       
  output reg          m_axi_arvalid       ,      //ַЧź                    
  input               m_axi_arready       ,      //ַ׼ź                   
  // Slave Interface Read Data Portsݶ˿źţ
  input     [3:0]     m_axi_rid           ,      //ID
  input     [127:0]   m_axi_rdata         ,      //                    
  input     [1:0]     m_axi_rresp         ,      //Ӧ   
  input               m_axi_rlast         ,      //һ
  input               m_axi_rvalid        ,      //Ч
  output              m_axi_rready               //ݾ
);
    localparam S_IDLE    = 7'b0000001,      //״̬
               S_ARB     = 7'b0000010,      //дٲ״̬
               S_WR_ADDR = 7'b0000100,      //дַ״̬
               S_WR_DATA = 7'b0001000,      //д״̬
               S_WR_RESP = 7'b0010000,      //ȴдӦ
               S_RD_ADDR = 7'b0100000,      //ַ״̬
               S_RD_RESP = 7'b1000000;      //ȴӦ
               
               
    reg [6:0] status; //״̬
    reg [6:0] nxt_status;
    
    wire wr_ddr3_req;
    wire rd_ddr3_req;
    
    reg      wr_rd_poll  ;  //0:allow wr  1:allow rd
    wire[5:0]wr_req_cnt_thresh;
    wire[5:0]rd_req_cnt_thresh;
    reg [7:0]wr_data_cnt ;
    
    //AXIӿźŵĲ
    //д
    assign m_axi_awid    = AXI_ID   ; //output [3:0]      m_axi_awid   
    assign m_axi_awsize  = 3'b100   ; //output [2:0]      m_axi_awsize 
    assign m_axi_awburst = 2'b01    ; //output [1:0]      m_axi_awburst
    assign m_axi_awlock  = 1'b0     ; //output [0:0]      m_axi_awlock 
    assign m_axi_awcache = 4'b0000  ; //output [3:0]      m_axi_awcache
    assign m_axi_awprot  = 3'b000   ; //output [2:0]      m_axi_awprot 
    assign m_axi_awqos   = 4'b0000  ; //output [3:0]      m_axi_awqos    
    assign m_axi_awlen   = AXI_LEN  ;
    
    assign m_axi_wstrb   = 16'hffff ; //output [15:0]     m_axi_wstrb 
    assign m_axi_wdata   = wr_fifo_rddata;
    
    assign m_axi_bready  = 1'b1     ; //output            m_axi_bready
    
    //źŵĲ
    assign m_axi_arid    = AXI_ID   ; //output [3:0]      m_axi_arid   
    assign m_axi_arsize  = 3'b100   ; //output [2:0]      m_axi_arsize 
    assign m_axi_arburst = 2'b01    ; //output [1:0]      m_axi_arburst
    assign m_axi_arlock  = 1'b0     ; //output [0:0]      m_axi_arlock 
    assign m_axi_arcache = 4'b0000  ; //output [3:0]      m_axi_arcache
    assign m_axi_arprot  = 3'b000   ; //output [2:0]      m_axi_arprot 
    assign m_axi_arqos   = 4'b0000  ; //output [3:0]      m_axi_arqos
    assign m_axi_arlen   = AXI_LEN  ;
    
    assign m_axi_rready  = ~rd_fifo_alfull; //output            m_axi_rready

    //дFIFOӿڵ    
    assign wr_fifo_rdreq = m_axi_wvalid && m_axi_wready; //дFIFOź
    assign rd_fifo_wrreq = m_axi_rvalid && m_axi_rready; //FIFOź
    assign rd_fifo_wrdata = m_axi_rdata;
    
    assign wr_req_cnt_thresh = (m_axi_awlen == 1'b0)? 1'b0 : AXI_LEN-1'b1;//дݼ
    assign rd_req_cnt_thresh = AXI_LEN;
    assign wr_ddr3_req = (wr_fifo_rst_busy == 1'b0) && (wr_fifo_rd_cnt >= wr_req_cnt_thresh) ? 1'b1:1'b0;//дݳAXI_LENֵʱдź
    assign rd_ddr3_req = (rd_fifo_rst_busy == 1'b0) && (rd_fifo_wr_cnt <= rd_req_cnt_thresh) ? 1'b1:1'b0;//СAXI_LENʱź
        
    //Ҫдĵַm_axi_awaddr
    always@(posedge ui_clk or posedge ui_clk_sync_rst)
    begin
      if(ui_clk_sync_rst)
        m_axi_awaddr <= WR_DDR_BYTE_ADDR_BEGIN;
      else if(wr_addr_clr)
        m_axi_awaddr <= WR_DDR_BYTE_ADDR_BEGIN;
      else if(m_axi_awaddr >= WR_DDR_BYTE_ADDR_END)
        m_axi_awaddr <= WR_DDR_BYTE_ADDR_BEGIN;
      else if((status == S_WR_RESP) && m_axi_bready && m_axi_bvalid && (m_axi_bresp == 2'b00) && (m_axi_bid == AXI_ID))
        m_axi_awaddr <= m_axi_awaddr + ((m_axi_awlen + 1'b1)<<4);
      else
        m_axi_awaddr <= m_axi_awaddr;
    end
    
    //дַЧźm_axi_awvalid
    always@(posedge ui_clk or posedge ui_clk_sync_rst)
    begin
      if(ui_clk_sync_rst)
        m_axi_awvalid <= 1'b0;
      else if((status == S_WR_ADDR) && m_axi_awready && m_axi_awvalid)
        m_axi_awvalid <= 1'b0;
      else if(status == S_WR_ADDR)
        m_axi_awvalid <= 1'b1;
      else
        m_axi_awvalid <= m_axi_awvalid;
    end

      //дЧm_axi_wvalid
    always@(posedge ui_clk or posedge ui_clk_sync_rst)
    begin
      if(ui_clk_sync_rst)
        m_axi_wvalid <= 1'b0;
      else if((status == S_WR_DATA) && m_axi_wready && m_axi_wvalid && m_axi_wlast)
        m_axi_wvalid <= 1'b0;
      else if(status == S_WR_DATA)
        m_axi_wvalid <= 1'b1;
      else
        m_axi_wvalid <= m_axi_wvalid;
    end

     //wr_data_cnt  
    always@(posedge ui_clk or posedge ui_clk_sync_rst)
    begin
      if(ui_clk_sync_rst)
        wr_data_cnt <= 1'b0;
      else if(status == S_ARB)
        wr_data_cnt <= 1'b0;
      else if(status == S_WR_DATA && m_axi_wready && m_axi_wvalid)
        wr_data_cnt <= wr_data_cnt + 1'b1;
      else
        wr_data_cnt <= wr_data_cnt;
    end
        
    //һֽڵźm_axi_wlast
    always@(posedge ui_clk or posedge ui_clk_sync_rst)
    begin
      if(ui_clk_sync_rst)
        m_axi_wlast <= 1'b0;
      else if(status == S_WR_DATA && m_axi_wready && m_axi_wvalid && m_axi_wlast)
        m_axi_wlast <= 1'b0;
      else if(status == S_WR_DATA && m_axi_awlen == 8'd0)
        m_axi_wlast <= 1'b1;
      else if(status == S_WR_DATA && m_axi_wready && m_axi_wvalid && (wr_data_cnt == m_axi_awlen -1'b1))
        m_axi_wlast <= 1'b1;
      else
        m_axi_wlast <= m_axi_wlast;
    end    

    
    //һͻĶַm_axi_araddrһдַ֮ӣm_axi_arlen+1'b1 >> 4
    always@(posedge ui_clk or posedge ui_clk_sync_rst)
    begin
      if(ui_clk_sync_rst)
        m_axi_araddr <= RD_DDR_BYTE_ADDR_BEGIN;
      else if(rd_addr_clr)
        m_axi_araddr <= RD_DDR_BYTE_ADDR_BEGIN;
      else if(m_axi_araddr >= RD_DDR_BYTE_ADDR_END)
        m_axi_araddr <= RD_DDR_BYTE_ADDR_BEGIN;
      else if((status == S_RD_RESP) && m_axi_rready && m_axi_rvalid && m_axi_rlast && (m_axi_rresp == 2'b00) && (m_axi_rid == AXI_ID))
        m_axi_araddr <= m_axi_araddr + ((m_axi_awlen + 1'b1)<<4);
      else
        m_axi_araddr <= m_axi_araddr;
    end
     
    //ַЧźm_axi_arvalid
    always@(posedge ui_clk or posedge ui_clk_sync_rst)
    begin
      if(ui_clk_sync_rst)
        m_axi_arvalid <= 1'b0;
      else if((status == S_RD_ADDR) && m_axi_arready && m_axi_arvalid)
        m_axi_arvalid <= 1'b0;
      else if(status == S_RD_ADDR)
        m_axi_arvalid <= 1'b1;
      else
        m_axi_arvalid <= m_axi_arvalid;
    end
    
    always@(posedge ui_clk or posedge ui_clk_sync_rst)
    begin
      if(ui_clk_sync_rst)
        wr_rd_poll <= 1'b0;
      else if(status == S_ARB)
        wr_rd_poll <= ~wr_rd_poll;
      else
        wr_rd_poll <= wr_rd_poll;
    end
    
  always@(posedge ui_clk or posedge ui_clk_sync_rst)
  begin
    if(ui_clk_sync_rst)
      status <= S_IDLE;
    else
      status <= nxt_status;
  end

  always@(*)
  begin
    case(status)
      S_IDLE:
      begin
        if(mmcm_locked && init_calib_complete)
          nxt_status = S_ARB;
        else
          nxt_status = S_IDLE;
      end

      S_ARB:
      begin
        if((wr_ddr3_req == 1'b1) && (wr_rd_poll == 1'b0))
          nxt_status = S_WR_ADDR;
        else if((rd_ddr3_req == 1'b1) && (wr_rd_poll == 1'b1))
          nxt_status = S_RD_ADDR;
        else
          nxt_status = S_ARB;
      end

      S_WR_ADDR:
      begin
        if(m_axi_awready && m_axi_awvalid)
          nxt_status = S_WR_DATA;
        else
          nxt_status = S_WR_ADDR;
      end

      S_WR_DATA:
      begin
        if(m_axi_wready && m_axi_wvalid && m_axi_wlast)
          nxt_status = S_WR_RESP;
        else
          nxt_status = S_WR_DATA;
      end

      S_WR_RESP:
      begin
        if(m_axi_bready && m_axi_bvalid && (m_axi_bresp == 2'b00) && (m_axi_bid == AXI_ID))
          nxt_status = S_ARB;
        else if(m_axi_bready && m_axi_bvalid)
          nxt_status = S_IDLE;
        else
          nxt_status = S_WR_RESP;
      end

      S_RD_ADDR:
      begin
        if(m_axi_arready && m_axi_arvalid)
          nxt_status = S_RD_RESP;
        else
          nxt_status = S_RD_ADDR;
      end

      S_RD_RESP:
      begin
        if(m_axi_rready && m_axi_rvalid && m_axi_rlast && (m_axi_rresp == 2'b00) && (m_axi_rid == AXI_ID))
          nxt_status = S_ARB;
        else if(m_axi_rready && m_axi_rvalid && m_axi_rlast)
          nxt_status = S_IDLE;
        else
          nxt_status = S_RD_RESP;
      end

      default: nxt_status = S_IDLE;
    endcase
  end

endmodule
