`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/02/23 14:39:01
// Design Name: 
// Module Name: uart_cmd_rx
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module uart_cmd_rx(
clk,
reset,
uart_baud_set,
adc_ch_sel,
set_sample_num,
set_sample_speed,
start_sample,
cmdvalid,
cmd_addr,
cmd_data
    );
input clk;
input reset;
input [31:0]cmd_data;
input cmdvalid;
input [7:0]cmd_addr;
output reg [2:0]uart_baud_set;
output reg [1:0]adc_ch_sel;
output reg [15:0]set_sample_num;
output reg start_sample;
output reg [31:0]set_sample_speed;

    
  always@(posedge clk or posedge reset)
  if(reset)begin
    uart_baud_set <= 3'd4; //Ĭ115200bps
    adc_ch_sel <= 2'b00;
    set_sample_num <= 16'd32768;//趨Ϊ4G
    start_sample <= 1'b0;
    set_sample_speed <= 32'd0; //50M 
  end
  else if(cmdvalid)begin
    case(cmd_addr)
        0: start_sample <= 1'b1;
        1: adc_ch_sel <= cmd_data[1:0];
        2: set_sample_num <= cmd_data[15:0];
        3: set_sample_speed <= cmd_data[31:0];
        4:
          begin
            adc_ch_sel <= cmd_data[1:0];
            set_sample_num <= cmd_data[23:8];
            start_sample <= 1'b1;
          end
        5: uart_baud_set <= cmd_data[2:0];
      default:;
    endcase
  end
  else
    start_sample <= 1'b0;
endmodule
